package tuitate_4_1_4;

import java.applet.Applet;
import java.awt.*;

public class TuitateLoader extends Applet implements Runnable
{
  final int WIDTH = 640;
  final int HEIGHT = 480;

  Image doubleBuffer;
  Graphics dg;

  Thread th;

  boolean threadRestart = true; 

  public final static String VERSION = "4.1.4";
  
  String className[] = {"Tpoint","Piece","Member","Logger","Screen",
                        "ButtonGroup","Connection","DataList","PieceKind",
                        "Board","Hand","Cursor","TextCanvas","InputWindow",
			"GameData","Mode","NewtralMode","SelectEnemyMode",
                        "SelectGameMode","SelectNotationMode","GameMode",
			"ViewMode","TuitateShogi"};
  
  int classSize[] = {810,773,1105,1256,3499,
                     2376,3028,501,1463,
                     3694,7159,7171,944,3620,
                     1479,1633,2550,7304,
                     6357,6944,10040,
                     11519,8102};
  
  public void init()
  {
    resize(WIDTH,HEIGHT);
    
    doubleBuffer = createImage(WIDTH,HEIGHT);
    dg = doubleBuffer.getGraphics();
    
    th = new Thread(this);
    th.start();
  }
  
  public void paint(Graphics g)
  {
    threadRestart = false;
    g.drawImage(doubleBuffer,0,0,null);
    threadRestart = true;
  }

  public void update(Graphics g)
  {
    paint(g);
  }
  
  void drawClassName(int number,Graphics g,Color col)
  {
    int x = 60+(number/9)*160;
    int y = 80+(number%9)*35;

    drawStr(g,x,y+19,className[number],col,18);
    drawStr(g,x+100,y+35,String.valueOf(classSize[number]),col,12);
  }

  void fillRec(Graphics g,int x,int y,int w,int h,Color col)
  {
    g.setColor(col);
    g.fillRect(x,y,w,h);
  }
  
  void drawStr(Graphics g,int x,int y,String str,Color col,int size)
  {
    g.setColor(col);
    g.setFont(new Font("Helvetica",Font.BOLD,size));
    g.drawString(str,x,y);
  }

  public void start()
  {}

  public void run()
  {
    dg.setColor(Color.black);
    dg.fillRect(0,0,WIDTH,HEIGHT);
    
    fillRec(dg,65,25,540,50,new Color(0,0,100));
    fillRec(dg,50,10,540,50,new Color(0,0,200));
    drawStr(dg,60,50,"Welcome to TUITATE SHOGI",Color.orange,35);
    repaint();
    waitForPaint();
    
    fillRec(dg,65,95,540,335,new Color(50,50,50));
    fillRec(dg,50,70,540,335,new Color(100,100,100));
    for(int i=0;i<className.length;i++)
    drawClassName(i,dg,Color.blue);
    repaint();
    waitForPaint();
    
    fillRec(dg,65,435,540,35,new Color(50,0,0));
    fillRec(dg,50,420,540,35,new Color(100,0,0));
    drawStr(dg,70,445,"Class loading   Please Wait ...",Color.white,20);
    repaint();
    waitForPaint();    

    boolean failed = false;
    for(int i=0;i<className.length;i++)
    {
      try {
        drawClassName(i,dg,Color.yellow);
        repaint();
	waitForPaint();
        Class.forName("tuitate_"+VERSION.replace('.','_')+"."+className[i]);
        drawClassName(i,dg,Color.green);
        repaint();
	waitForPaint();	
      } catch ( Exception e) {
	failed = true;
        drawClassName(i,dg,Color.red);
      }
    }

    fillRec(dg,65,435,540,35,new Color(50,0,0));
    fillRec(dg,50,420,540,35,new Color(100,0,0));
    if(failed)
    {
      drawStr(dg,70,445,"Some Classes are not loaded succesfully.",
	      Color.yellow,20);
      repaint();
    }
    else      
    {
      drawStr(dg,70,445,"All class is loaded.  Enjoy !!",Color.white,20);
      repaint();
    }

  }

  void waitForPaint()
  {
    while(!threadRestart)
    {
      try {
	th.sleep(50);
      } catch (Exception e) {}
    }
  }
  
}


